
#include "gen_lang.hh"
#include "gen_lang_loader.hh"

class SC_GenericLang : public SC_GenericLangLoader,
		       public SC_Language {
private:
  void set();
public:
  SC_GenericLang(const string &lang, const string &path);
  SC_GenericLang(const SC_GenericLang &);
  SC_GenericLang& operator=(const SC_GenericLang &);
  SC_Language * clone() const;
  ~SC_GenericLang();
};

void SC_GenericLang::set() {
  SC_Language::name_ = SC_GenericLangLoader::name_;
  SC_Language::to_lower_ = SC_GenericLangLoader::to_lower_;
  SC_Language::to_upper_ = SC_GenericLangLoader::to_upper_;
  SC_Language::is_alpha_ = SC_GenericLangLoader::is_alpha_;
  SC_Language::soundslike_chars_ = SC_GenericLangLoader::soundslike_chars_;
}

SC_GenericLang::SC_GenericLang(const string &lang, const string &path) 
  : SC_GenericLangLoader(lang, path)
{
  set();
}

SC_GenericLang::SC_GenericLang(const SC_GenericLang &other) 
  : SC_GenericLangLoader(other) {}

SC_GenericLang& SC_GenericLang::operator=(const SC_GenericLang &other) {
  destroy();
  copy_in(other);
  set();
  return *this;
}

SC_Language * SC_GenericLang::clone() const {
  return new SC_GenericLang(*this);
}

SC_GenericLang::~SC_GenericLang() {}

SC_Language * new_SC_GenericLang(const string &lang, const string &path) {
  return new SC_GenericLang(lang,path);
}
